library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use work.math_pack.all;

--------------ENTITY----------------------------------------
entity errdec is
   generic(PRM: integer	 
	  );
   port( 
      errin  : in std_logic_vector(PRM-1 downto 0);
      stop : out std_logic;  
      errout : out std_logic_vector(log2(PRM)-1 downto 0) 
       ); 
end errdec;

--------------ARCHITECTURE----------------------------------
architecture behav of errdec is

begin

process(errin)
begin
    stop <= '0';	
    errout <= (OTHERS => '0');
    for i in 0 to PRM-1 loop
        if (errin(i)='1') then
            errout <= conv_std_logic_vector(i, log2(PRM));
	          stop <= '1';
        end if;
	  end loop;	
end process;

end behav;
