library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use work.math_pack.all;

--------------ENTITY----------------------------------------
entity input_register is
   generic(PRM: integer	 
	  );
   port( 
      clk         : in std_logic;
      rst         : in std_logic;  -- globar reset
      clear	      : in std_logic;  -- clear register
      data_in	    : in std_logic_vector(PRM-1 downto 0); -- Err PRMs
      data_out	  : out std_logic_vector(PRM-1 downto 0) -- Err PRMs
      ); 
end input_register;

-----------------------------------------------------------------------------
--------------ARCHITECTURE---------------------------------------------------
-----------------------------------------------------------------------------
architecture behav of input_register is

signal reg: std_logic_vector(PRM-1 downto 0); -- error registers

begin

    process(clk, rst, clear)
    begin
        if (rst = '1') or (clear = '1') then
            reg <= (others => '0');
        elsif rising_edge(clk) then    
            reg <= reg or data_in;
        end if;
    end process;

    data_out <= reg;
    
end behav;
