--Implementation o round robin by shift register

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
--use work.math_pack.all;

entity roundrobin is
   generic(
      PRM: integer
   );
   port(
      clk	: in std_logic;
      rst	: in std_logic;
      --stop : in std_logic;
      enable	: in std_logic;
      enable_data_out : in std_logic;
      data_in	: in std_logic_vector(PRM-1 downto 0);
      data_out	: out std_logic_vector(PRM-1 downto 0);
      done      : out std_logic
   );
end roundrobin;

architecture sekventional of roundrobin is

    signal round_reg : std_logic_vector(PRM-1 downto 0);
    signal data_reg : std_logic_vector(PRM-1 downto 0);
   
begin
    shift_reg:process(clk, rst, enable)
    begin
        if(rst = '1') then
            round_reg(PRM-2 downto 0) <= (others => '0');
            round_reg(PRM-1) <= '1';
            data_reg <= (others => '0');
        elsif(clk'event and clk='1') then
            if(enable = '1') then
                round_reg <= round_reg(0) & round_reg(PRM-1 downto 1);
                data_reg <= data_in;
            end if;
        end if;
    end process;

    

    data_out <= (data_reg and round_reg) when (enable_data_out = '1') else (others => '0') ;
    done <= round_reg(0);
end sekventional;

