library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity safetyw is
    generic(
        VALUE: integer; 
	      BITS: integer
	  );
    port( 
        clk      : in std_logic;
        rst      : in std_logic;
        enable   : in std_logic;  -- end of reconfiguration process
        sync     : out std_logic -- synchronization of PRMs
    ); 
end safetyw;


architecture behav of safetyw is

	  signal cnt_reg : std_logic_vector(BITS-1 downto 0);
	  signal tmp : std_logic;

begin

    tmp <= '1' when (cnt_reg = conv_std_logic_vector(VALUE,BITS)) else '0';


    -----------------Counter of Safety Window-----------------
    process (clk, rst, enable)
    begin
        if (rst = '1') then
            cnt_reg <= (others => '0');
            sync <= '0';
        elsif rising_edge(clk) then
	          if (enable = '1') then
		            if ( tmp = '1') then
	  	              cnt_reg <= (others => '0');
		                sync <= '1';
		            else
	   	              cnt_reg <= cnt_reg + 1;
		                sync <= '0';
		            end if;
            end if;
        end if;
    end process;
end behav;

